// wmap.cpp : Defines the class behaviors for the application.
//

#define NWWIN 1
#ifndef FAR
	#define FAR far
#endif


#include "stdafx.h"

// includes for this app

#include "wmap.h"

#include "mainfrm.h"
#include "wmapdoc.h"
#include "wmapview.h"



#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif
        

void StripAllSpaces( char *String );
void StripAllQuotes( char *String );
void ParseSemiColonString( char *SourceString, char *FirstString );
void ParseSpaceString( char *SourceString, char *FirstString );
int GoToSubDirectory( char *DestDirectory );
int InstrI( int StartPoint, char *SourceBuffer, char *SearchBuffer );
int ReadConfigurationTypeFile( FILE *Text_FileHandle, char *TempString);
void Trim( char *SourceBuffer );

        
int InitNetworkStuff( void );
int MapTheDrive( int ForceIt );
void CleanUpGlobalData( void );


char	GlobalDefaultContext[ 81 ] = "";
char	GlobalDefaultServer[ 81 ] = "";
char	GlobalPreferredDSTree[ 81 ] = "";
char	GlobalUserObjectID[ 81 ] = "";
char	GlobalUserObjectName[ 81 ] = "";
char	GlobalCommandLine[ 129 ] = "";
int	GlobalDSConnection = FALSE;

char	GlobalPassword[ 40 ] = "";
char	GlobalServerName[ 40 ] = "";        
char	GlobalSubdirectoryName[ 80 ] = "";
char	GlobalUserName[ 40 ] = "";
char	GlobalDriveLetter[ 2 ] = "";
        

int	FAR	nDummy;

#pragma pack(1)

// common variables

char              DefaultContextName[ MAX_DN_CHARS + 1 ] = "";
NWDSContextHandle dContext;

NWCONN_HANDLE     UserConnectionId = 0;
DWORD             UserObjectID = 0;
char              UserObjectName[ MAX_DN_CHARS + 1 ] = "";
char              DefaultServerName[ 49 ];
char              TreeName[ MAX_DN_CHARS + 1 ] = "";

char  MasterOriginalDirectory[ 255 ] = "";
char  RootDirectory[ 256 ];


        
/////////////////////////////////////////////////////////////////////////////
// CWmapApp

BEGIN_MESSAGE_MAP(CWmapApp, CWinApp)
	//{{AFX_MSG_MAP(CWmapApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWmapApp construction

CWmapApp::CWmapApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CWmapApp object

CWmapApp NEAR theApp;

/////////////////////////////////////////////////////////////////////////////
// CWmapApp initialization

BOOL CWmapApp::InitInstance()
{  
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

	SetDialogBkColor();        // Set dialog background color to gray
	// LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CWmapDoc),
		RUNTIME_CLASS(CMainFrame),     // main SDI frame window
		RUNTIME_CLASS(CWmapView));
	AddDocTemplate(pDocTemplate);

	// create a new (empty) document


   if (InitNetworkStuff() == NUNSUCCESSFUL )
		PostQuitMessage(0);

		
	if (m_lpCmdLine[0] != '\0')
		{
		char	TempString[ 256 ];
		char	TempString2[ 256 ];

		strcpy( TempString, m_lpCmdLine );
		strupr( TempString );
      strcpy( GlobalCommandLine, TempString );
	
		ParseSpaceString( TempString, TempString2 );
		TempString2[ 1 ] = '\0';
		strcpy( GlobalDriveLetter, TempString2 );
	
		ParseSpaceString( TempString, TempString2 );
		TempString2[ 40 ] = '\0';
		strcpy( GlobalServerName, TempString2 );
	
		ParseSpaceString( TempString, TempString2 );
		TempString2[ 40 ] = '\0';
		strcpy( GlobalUserName, TempString2 );
	
		ParseSpaceString( TempString, TempString2 );
		TempString2[ 40 ] = '\0';
		strcpy( GlobalPassword, TempString2 );
	
		ParseSpaceString( TempString, TempString2 );
		TempString2[ 80 ] = '\0';
		strcpy( GlobalSubdirectoryName, TempString2 );
		}

	OnFileNew();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CWmapApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CWmapApp commands


/*-------------------------------------------------------------------------*/
void Trim( char *SourceBuffer )
   {
   int TempInt;
   if (SourceBuffer[0] == '\0') return;

   /* work on leading spaces */
   if (SourceBuffer[0] == ' ')
      {
      int SourceLength;
      SourceLength = strlen( SourceBuffer );

      for (TempInt = 0; TempInt < SourceLength; TempInt++)
         if (SourceBuffer[TempInt] != ' ')
            break;

      if ( TempInt == SourceLength )
         {
         SourceBuffer[0]='\0';
         return;
         }
      else
         memmove(SourceBuffer, (SourceBuffer+TempInt), SourceLength+1 );
      }

   /* work on trailing spaces */
   for (TempInt=strlen(SourceBuffer)-1; TempInt>=0; TempInt--)
      if (SourceBuffer[TempInt] == ' ')
         SourceBuffer[TempInt]='\0';
      else
         break;
   }
/**End of Function**/



/*-------------------------------------------------------------------------*/
int InChar( int StartPoint, char *SourceBuffer, int Ch )
   {
   register int TempInt;
   register int TempMax;
   if ( (SourceBuffer[0] == '\0') || ( StartPoint == 0) )
      return( 0 );

   TempMax = strlen( SourceBuffer );

   for (TempInt = StartPoint-1; TempInt <= TempMax; TempInt++ )
      if ( SourceBuffer[ TempInt ]== Ch )
         return( TempInt + 1 );

   if ( Ch == 0 )
      return( strlen( SourceBuffer ) +1 );

   return( 0 );
   }
/**End of Function**/



/*-------------------------------------------------------------------------*/
int ReadConfigurationTypeFile( FILE *Text_FileHandle, char *TempString)
   {
   int   TempInt;
   int   TempMax;

   while( TRUE == TRUE)
      {
      TempString[ 0 ] = '\0';
      /*
      if (feof( Text_FileHandle ) != 0)
         {
         clearerr( Text_FileHandle );
         return( UNSUCCESSFUL );
         }
      */

      if (fgets( TempString, 255, Text_FileHandle ) == NULL )
         {
         clearerr( Text_FileHandle );
         return( UNSUCCESSFUL );
         }

      if ( TempString[ 0 ] == ';')     continue;
      if ( TempString[ 0 ] == '\x27')  continue;
      if ( TempString[ 0 ] == '\x1B')  continue;
      if ( TempString[ 0 ] == '\0')    continue;

      TempMax = strlen( TempString ) -1;
      if (TempString[ TempMax ] == '\n')
         TempString[ TempMax ] = '\0';
      for( TempInt = 0; TempInt < TempMax; TempInt++ )
         {
         if (TempString[ TempInt ] == '\r')
            TempString[ TempInt ] = ' ';
         if (TempString[ TempInt ] == '\b')
            TempString[ TempInt ] = '\0';
         if (TempString[ TempInt ] == '\f')
            TempString[ TempInt ] = ' ';
         if (TempString[ TempInt ] == '\x09')
            TempString[ TempInt ] = ' ';
         }

      Trim( TempString );
      if ( TempString[ 0 ] == ';')     continue;
      if ( TempString[ 0 ] == '\x27')  continue;
      if ( TempString[ 0 ] == '\x1B')  continue;
      if ( TempString[ 0 ] == '\0')    continue;

      return( NSUCCESSFUL );
      }
   return( NSUCCESSFUL );
   }
/**End of Function**/



/*-------------------------------------------------------------------------*/
int InstrI( int StartPoint, char *SourceBuffer, char *SearchBuffer )
   {
   char  UpperCaseSearchBuffer[ 64 ];
   register int   TempInt, TempInt1, TempInt2;
   int   FoundFlag;

   int len_SourceBuffer, len_SearchBuffer;

   memcpy( UpperCaseSearchBuffer, SearchBuffer, 62 );
   UpperCaseSearchBuffer[ 62 ] = '\0';
   strupr( UpperCaseSearchBuffer );

   len_SourceBuffer = strlen( SourceBuffer );
   len_SearchBuffer = strlen( UpperCaseSearchBuffer );

   if ( len_SearchBuffer == 0 )
      if ( len_SourceBuffer > 0 )
         return( 1 );
      else
         return( 0 );
   if ( (len_SourceBuffer == 0) || ( StartPoint == 0) )
      return( 0 );

   TempInt2 = len_SourceBuffer - len_SearchBuffer+1;

   for( TempInt = StartPoint-1; TempInt < TempInt2; TempInt++ )
      {
      FoundFlag = TRUE;
      for (TempInt1 = 0; TempInt1 < len_SearchBuffer; TempInt1++)
         {
         if (SourceBuffer[ TempInt + TempInt1 ] > 96)
            if ( (SourceBuffer[ TempInt + TempInt1 ] - 32) == UpperCaseSearchBuffer[ TempInt1 ])
               continue;

         if ( SourceBuffer[ TempInt + TempInt1 ] != UpperCaseSearchBuffer[ TempInt1 ])
            {
            FoundFlag = FALSE;
            break;
            }
         }
      if (FoundFlag == TRUE) return( TempInt + 1 );
      }

   return(0);
   }
/**End of Function**/


/*-------------------------------------------------------------------------*/
int GoToSubDirectory( char *DestDirectory )
   {
   int   DestDrive;
   int   StartLocation;

   strupr( DestDirectory );

   if ((DestDirectory[1] == ':') && (strlen( DestDirectory ) > 0))
      {
      DestDrive = DestDirectory[0] - '@';
      if (_chdrive( DestDrive ) != 0)
         return( UNSUCCESSFUL );
      StartLocation = 2;
      }
   else
      StartLocation = 0;

   if (strlen( DestDirectory + StartLocation ) > 0)
      if (chdir( DestDirectory ) != 0)
         return( UNSUCCESSFUL );

   return( NSUCCESSFUL );
   }
/* end of function */



/*-------------------------------------------------------------------------*/
void ParseSpaceString( char *SourceString, char *FirstString )
   {
   int   TempInt  = 0;
   int   TempInt2 = 0;

   Trim( SourceString );
   TempInt  = InChar( 1, SourceString, ' ');
   if (TempInt > 0)
      {
      if (TempInt > 127)
         TempInt = 127;

      memcpy( FirstString, SourceString, TempInt );
      FirstString[ TempInt - 1 ] = '\0';

      for(TempInt2 = 0; TempInt2 < TempInt; TempInt2++)
         SourceString[ TempInt2 ] = ' ';

      Trim( SourceString );
      Trim( FirstString );
      }
   else
      {
      strcpy( FirstString, SourceString );
      Trim( FirstString );
      SourceString[ 0 ] = '\0';
      }
   }
/* end of function */


/*-------------------------------------------------------------------------*/
void ParseSemiColonString( char *SourceString, char *FirstString )
   {
   int   TempInt  = 0;
   int   TempInt2 = 0;

   Trim( SourceString );
   TempInt  = InChar( 1, SourceString, ';');
   if (TempInt > 0)
      {
      if (TempInt > 127)
         TempInt = 127;

      memcpy( FirstString, SourceString, TempInt );
      FirstString[ TempInt - 1 ] = '\0';

      for(TempInt2 = 0; TempInt2 < TempInt; TempInt2++)
         SourceString[ TempInt2 ] = ' ';

      Trim( SourceString );
      Trim( FirstString );
      }
   else
      {
      strcpy( FirstString, SourceString );
      Trim( FirstString );
      SourceString[ 0 ] = '\0';
      }
   }
/* end of function */


/*-------------------------------------------------------------------------*/
void StripAllSpaces( char *String )
   {
   int TempInt;
   int TempMax;

   while( TRUE == TRUE )
      {
      TempInt = InChar( 1, String, ' ');
      if (TempInt == 0)
         break;
      if (TempInt == 1)
         Trim( String );
      if (TempInt > 1)
         {
         TempMax = strlen( String + TempInt ) +1;
         memmove( String + TempInt - 1, String + TempInt, TempMax );
         }
      }
   }
/* end of function */


/*-------------------------------------------------------------------------*/
void StripAllQuotes( char *String )
   {
   int TempInt;
   int TempMax;

   while( TRUE == TRUE )
      {
      TempInt = InChar( 1, String, '\x22');
      if (TempInt == 0)
         break;
      TempMax = strlen( String + TempInt ) +1;
      memmove( String + TempInt - 1, String + TempInt, TempMax );
      }
   }
/* end of function */


   
int MapTheDrive( int ForceIt )
	{    
	CONNECT_INFO			ConnectionInfo;
	NWDS_Session_Key_T   sessionKey;    
	NWCONN_HANDLE        OriginalConnectionHandle;    
	NWCONN_HANDLE        ConnectionHandle;    
	NWCCODE              CompletionCode;
	// NWCCODE              DSIsAvailable;    
	WORD                 DriveNumber;    
	WORD						DriveLetterStatus;
	char                 ServerName[50];    
	char                 *VolumePath;
	char						Password[ 41 ] = "";

	char	DriveLetter[ 2 ];
	char	FullNetwarePath[ 257 ];
	char	TempString[ 257 ];
	char	TempString2[ 257 ];
	
	
	CleanUpGlobalData();
                  
	strcpy( Password, GlobalPassword );                  
   
	strcpy( DriveLetter, GlobalDriveLetter );
	strcpy( FullNetwarePath, GlobalServerName );
	strcat( FullNetwarePath, "/" );
	if (InChar( 1, GlobalSubdirectoryName, ':') == 0)
		strcat( FullNetwarePath, "SYS:" );
	strcat( FullNetwarePath, GlobalSubdirectoryName );
   
	DriveNumber = DriveLetter[ 0 ] - '@';    
	CompletionCode = NWGetDriveStatus(DriveNumber, 0, &DriveLetterStatus, 
							&OriginalConnectionHandle, NULL, NULL, NULL);    
	if(CompletionCode)    
		{       
		if(CompletionCode == NW_INVALID_DRIVE)          
			{
			sprintf( TempString, "Error: %s: is an invalid Drive letter.", DriveLetter);
			CStatusDialog WorkDlg;
			WorkDlg.m_StatusDialog1 = TempString;
			WorkDlg.DoModal();			
			return( NUNSUCCESSFUL );
			}
		else          
			{
			CStatusDialog WorkDlg;
			WorkDlg.m_StatusDialog1 = "Error: Unable to find drive status.";
			WorkDlg.DoModal();			
			return( NUNSUCCESSFUL );
			}
		sprintf( TempString, "Error: NWGetDriveStatus() returned x%04X", CompletionCode );
		CStatusDialog WorkDlg;
		WorkDlg.m_StatusDialog1 = TempString;
		WorkDlg.DoModal();			
		return( NUNSUCCESSFUL );
		}            
		             
	if(DriveLetterStatus != NW_UNMAPPED_DRIVE)    
		{       
		if (ForceIt == FALSE)
			{
			sprintf( TempString, "Error: Drive %s: is already in use.", DriveLetter);
			CStatusDialog WorkDlg;
			WorkDlg.m_StatusDialog1 = TempString;
			WorkDlg.DoModal();			
			return( NUNSUCCESSFUL );
			}
		else
			{
			NWDeleteDriveBase( DriveNumber, 0 );
			}
		}    
		
	CompletionCode = NWParsePath( FullNetwarePath, ServerName, &ConnectionHandle, NULL, NULL);    
	
	CompletionCode = NWGetConnectionStatus( ConnectionHandle, &ConnectionInfo, sizeof( CONNECT_INFO ));
	if (! (ConnectionInfo.connectFlags & CONNECTION_LOGGED_IN))
		{
		CompletionCode = NWAttachToFileServer( ServerName, 0, &ConnectionHandle);          
		if(( CompletionCode ) && ( CompletionCode != 0x8800))         
			{             
			CStatusDialog WorkDlg;
			sprintf( TempString, "Error: Could not attach to file server %s", ServerName);
			WorkDlg.m_StatusDialog1 = TempString;
			sprintf( TempString2, "Error: NWAttachToFileServer() returned x%04X", CompletionCode );
			WorkDlg.m_StatusDialog2 = TempString2;
			WorkDlg.DoModal();			
			return( NUNSUCCESSFUL );
			}          
		NWDSAuthenticate(ConnectionHandle, 0L, &sessionKey);          
		NWGetConnectionStatus( ConnectionHandle, &ConnectionInfo, sizeof( CONNECT_INFO ));
			
		if (! (ConnectionInfo.connectFlags & CONNECTION_NDS))
			{
			CompletionCode = NWLoginToFileServer( ConnectionHandle, GlobalUserName, OT_USER, Password );
			if( CompletionCode )
				{             
				sprintf( TempString, "Error: NWLoginToFileServer() returned x%04X", CompletionCode );
				CStatusDialog WorkDlg;
				WorkDlg.m_StatusDialog1 = TempString;
				sprintf( TempString2, "Name: %s Password: %s", GlobalUserName, Password );
				WorkDlg.m_StatusDialog2 = TempString2;
				WorkDlg.DoModal();			
				}
			}
		else
			{
			CompletionCode = NWDSAuthenticate(ConnectionHandle, 0L, &sessionKey);          
			if(CompletionCode)          
				{             
				sprintf( TempString, "Return Code: x%04X", CompletionCode);
				CStatusDialog WorkDlg;
				WorkDlg.m_StatusDialog1 = "Error authenticating to server";             
				WorkDlg.m_StatusDialog2 = TempString;             
				WorkDlg.DoModal();			
				return( NUNSUCCESSFUL );
         	}
         }
			
		}			

	/*
	if (CompletionCode == NO_CONNECTION_TO_SERVER)    
		{       
		DSIsAvailable = NWIsDSAuthenticated();       
		if ( ! DSIsAvailable )
			{          
			sprintf( TempString, "Error: You are not logged into %s.", ServerName );
			CStatusDialog WorkDlg;
			WorkDlg.m_StatusDialog1 = TempString;
			WorkDlg.DoModal();			
			return( NUNSUCCESSFUL );
			}       
		else       
			{          
			CompletionCode = NWAttachToFileServer( ServerName, 0, &ConnectionHandle);          
			if( CompletionCode )          
				{             
				sprintf( TempString, "Error: Could not attach to file server %s", ServerName);
				CStatusDialog WorkDlg;
				WorkDlg.m_StatusDialog1 = TempString;
				WorkDlg.DoModal();			
				return( NUNSUCCESSFUL );
				}          
			CompletionCode = NWDSAuthenticate(ConnectionHandle, 0L, &sessionKey);          
			if(CompletionCode)          
				{             
				sprintf( TempString, "Return Code: x%04X", CompletionCode);
				CStatusDialog WorkDlg;
				WorkDlg.m_StatusDialog1 = "Error authenticating to server";             
				WorkDlg.m_StatusDialog2 = TempString;             
				WorkDlg.DoModal();			
				return( NUNSUCCESSFUL );
         	}
      	}
   	}
	*/   	
   	
   VolumePath = NWStripServerOffPath( FullNetwarePath, NULL);
   CompletionCode = NWSetDriveBase(DriveNumber, ConnectionHandle, 0, VolumePath, 0);
   if(CompletionCode)   
   	{                                                      
		CStatusDialog WorkDlg;
   	sprintf( TempString, "Error: Drive %s: could not be mapped. Code = x%0X", DriveLetter, CompletionCode );
		WorkDlg.m_StatusDialog1 = TempString;
		if (CompletionCode == 0x8803)
   		strcpy( TempString2, "Your account does not have access to this subdirectory." );
		else		
   		sprintf( TempString2, "#:%d  Handle:%X  Path:%s",  DriveNumber, ConnectionHandle, VolumePath );
		WorkDlg.m_StatusDialog2 = TempString2;
		WorkDlg.DoModal();			
		return( NUNSUCCESSFUL );
   	}
   	
	CStatusDialog WorkDlg;
	WorkDlg.m_StatusDialog1 = "Map successfull!";
	sprintf( TempString2, "Drive %s: = %s", GlobalDriveLetter, FullNetwarePath );
	WorkDlg.m_StatusDialog2 = TempString2;
	WorkDlg.DoModal();			
	
	return( NSUCCESSFUL );
}  




/*-------------------------------------------------------------------------*/
int InitNetworkStuff( void )
   {
   NWCCODE        CompletionCode;
   LCONV          lconvInfo;
   DWORD          ContextFlags;
   char           TempString[ MAX_DN_CHARS + 1 ] = "";
   int            TempInt = 0, TempInt2 = 0;


   CompletionCode = NWCallsInit(NULL, NULL);
   if(CompletionCode)
      {        
      CStatusDialog StatusDlg;
      sprintf( TempString, "Error: Unable to initialize Network calls. (Error=x%X)", CompletionCode );
      StatusDlg.m_StatusDialog1 = TempString;
      StatusDlg.m_StatusDialog2 = "Verify that you are logged into a NetWare 4.10 server.";
      StatusDlg.DoModal();
      return( NUNSUCCESSFUL );
      }
		
   NWLsetlocale( LC_ALL, "");
   NWLlocaleconv( &lconvInfo );

	/* Set up locale information */
   CompletionCode = NWInitUnicodeTables( lconvInfo.country_id, lconvInfo.code_page );
   if( CompletionCode )
      {
      CStatusDialog StatusDlg;
      sprintf( TempString, "Error: NWInitUnicodeTables() returned: %04X", CompletionCode );
      StatusDlg.m_StatusDialog1 = TempString;
      StatusDlg.m_StatusDialog2 = "Verify that the Unicode files exist in the proper subdirectory..";
      StatusDlg.DoModal();
      return( NUNSUCCESSFUL );
      // printf( "UniCode files are usually in sys:\\public\\nls subdirectory.\n" );
      }
      
      
   CompletionCode = NWGetDefaultConnectionID( &UserConnectionId );
   if (CompletionCode != 0)
      {
      CStatusDialog StatusDlg;
      StatusDlg.m_StatusDialog1 = " ";
      sprintf( TempString, "Error: NWGetDefaultConnectionID = x%X", CompletionCode );
      StatusDlg.m_StatusDialog2 = TempString;
      StatusDlg.DoModal();
      return( NUNSUCCESSFUL );
      }

   CompletionCode = NWGetFileServerName( UserConnectionId, DefaultServerName );
   if (CompletionCode != 0)
      {
      CStatusDialog StatusDlg;
      StatusDlg.m_StatusDialog1 = " ";
      sprintf( TempString, "Error: NWGetFileServerName = x%X", CompletionCode );
      StatusDlg.m_StatusDialog2 = TempString;
      StatusDlg.DoModal();
      return( NUNSUCCESSFUL );
      }
   strcpy( GlobalDefaultServer, DefaultServerName );
   // printf( "Default Server     : %s\n", DefaultServerName );

   CompletionCode = NWIsDSServer( UserConnectionId, TreeName );
   if (CompletionCode == 0)
      {
      // CStatusDialog StatusDlg;
      // StatusDlg.m_StatusDialog1 = "Error:  This utility runs on a Netware 4.x server only!";
      // StatusDlg.m_StatusDialog2 = " ";
      // StatusDlg.DoModal();
      
      return( NSUCCESSFUL );
      }

	GlobalDSConnection = TRUE;
	
	// Below for DS connections only
   
  	if (! NWIsDSAuthenticated())
      {
      
      CStatusDialog StatusDlg;
      StatusDlg.m_StatusDialog1 = "Error: Not a Directory Services connection.";
      StatusDlg.m_StatusDialog2 = "Verify that you are running VLMs and logged into a Netware 4.10 server.";
      StatusDlg.DoModal();
      
		return( NSUCCESSFUL );
  		}
   
   strcpy( TempString, TreeName );
   TempInt2 = strlen( TempString ) -1;
   for( TempInt = TempInt2; TempInt > 0; TempInt-- )
      {
      if (TempString[ TempInt ] == '_')
         TempString[ TempInt ] = '\0';
      else
         break;
      }
   strcpy( GlobalPreferredDSTree, TempString );
   // printf( "Preferred DS Tree  : %s\n", TempString );

   TempInt = strlen( TreeName );
   CompletionCode = NWSetPreferredDSTree( TempInt, (unsigned char __far *) TreeName );
   if (CompletionCode != 0)
      {
      CStatusDialog StatusDlg;
      StatusDlg.m_StatusDialog1 = " ";
      sprintf( TempString, "Error: NWSetPreferredDSTree() = x%X", CompletionCode );
      StatusDlg.m_StatusDialog2 = TempString;
      StatusDlg.DoModal();
      }

   CompletionCode = NWGetPreferredDSServer( &UserConnectionId );
   if (CompletionCode != 0)
      {
      CStatusDialog StatusDlg;
      StatusDlg.m_StatusDialog1 = " ";
      sprintf( TempString, "Error: NWGetPreferredDSServer() = x%X", CompletionCode );
      StatusDlg.m_StatusDialog2 = TempString;
      StatusDlg.DoModal();
      return( NUNSUCCESSFUL );
      }
   
   dContext = NWDSCreateContext();
   if (dContext == ERR_CONTEXT_CREATION)
      {
      CStatusDialog StatusDlg;
      StatusDlg.m_StatusDialog1 = " ";
      StatusDlg.m_StatusDialog2 = "Error: NWDSCreateContext() could not create context";
      StatusDlg.DoModal();
      return( NUNSUCCESSFUL );
      }

   NWDSGetContext( dContext, DCK_FLAGS, &ContextFlags );
   ContextFlags |= DCV_TYPELESS_NAMES;
   // ContextFlags &= ~ DCV_CANONICALIZE_NAMES;
   CompletionCode = NWDSSetContext( dContext, DCK_FLAGS, &ContextFlags );
   if (CompletionCode != 0)
      {
      CStatusDialog StatusDlg;
      StatusDlg.m_StatusDialog1 = " ";
      sprintf( TempString, "Error: NWDSSetContext() = x%X", CompletionCode );
      StatusDlg.m_StatusDialog2 = TempString;
      StatusDlg.DoModal();
      return( NUNSUCCESSFUL );
      }

   if (NWDSWhoAmI(dContext, UserObjectName) == 0)
      {
      strcpy( GlobalUserObjectName, UserObjectName );
      // printf( "User Object Name is: %s\n", UserObjectName );
      }
	else
		{
	   strcpy( UserObjectName, "Unknown" );
      strcpy( GlobalUserObjectName, "Unknown" );
      }
		      
   if (NWDSGetContext( dContext, DCK_NAME_CONTEXT, DefaultContextName ) == 0)
      {
      strcpy( GlobalDefaultContext, DefaultContextName );
      // printf( "Current Context is : %s\n", DefaultContextName );
      }

   CompletionCode = NWDSMapNameToID( dContext, UserConnectionId,
                     UserObjectName, &UserObjectID );
   if (CompletionCode != 0)
      {
      CStatusDialog StatusDlg;
      StatusDlg.m_StatusDialog1 = " ";
      sprintf( TempString, "Error: NWDSMapNameToID() = x%X", CompletionCode );
      StatusDlg.m_StatusDialog2 = TempString;
      StatusDlg.DoModal();
      return( NUNSUCCESSFUL );
      }
   sprintf( GlobalUserObjectID, "%08lX", NWLongSwap( UserObjectID ) );   
   // printf( "User Object ID     : %08lX\n", NWLongSwap( UserObjectID ) );
      
   return( NSUCCESSFUL );
   }
/* end of function */



/////////////////////////////////////////////////////////////////////////////
// CIdentify dialog


CIdentify::CIdentify(CWnd* pParent /*=NULL*/)
	: CDialog(CIdentify::IDD, pParent)
{
	//{{AFX_DATA_INIT(CIdentify)
	m_CommandLine = "";
	m_DefaultContext = "";
	m_DefaultServer = "";
	m_ObjectID = "";
	m_ObjectName = "";
	m_PreferredDSTree = "";
	//}}AFX_DATA_INIT

	m_CommandLine = GlobalCommandLine;
	m_DefaultContext = GlobalDefaultContext;
	m_DefaultServer = GlobalDefaultServer;
	m_ObjectName = GlobalUserObjectName;
	m_ObjectID = GlobalUserObjectID;
	m_PreferredDSTree = GlobalPreferredDSTree;

}

void CIdentify::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIdentify)
	DDX_Text(pDX, IDC_CommandLine, m_CommandLine);
	DDV_MaxChars(pDX, m_CommandLine, 128);
	DDX_Text(pDX, IDC_DefaultContext, m_DefaultContext);
	DDV_MaxChars(pDX, m_DefaultContext, 80);
	DDX_Text(pDX, IDC_DefaultServer, m_DefaultServer);
	DDV_MaxChars(pDX, m_DefaultServer, 80);
	DDX_Text(pDX, IDC_ObjectID, m_ObjectID);
	DDV_MaxChars(pDX, m_ObjectID, 80);
	DDX_Text(pDX, IDC_ObjectName, m_ObjectName);
	DDV_MaxChars(pDX, m_ObjectName, 80);
	DDX_Text(pDX, IDC_PreferredDSTree, m_PreferredDSTree);
	DDV_MaxChars(pDX, m_PreferredDSTree, 80);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CIdentify, CDialog)
	//{{AFX_MSG_MAP(CIdentify)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CIdentify message handlers
/////////////////////////////////////////////////////////////////////////////
// CStatusDialog dialog


CStatusDialog::CStatusDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CStatusDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStatusDialog)
	m_StatusDialog1 = "";
	m_StatusDialog2 = "";
	//}}AFX_DATA_INIT
}

void CStatusDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStatusDialog)
	DDX_Text(pDX, IDC_StatusDialog1, m_StatusDialog1);
	DDV_MaxChars(pDX, m_StatusDialog1, 256);
	DDX_Text(pDX, IDC_StatusDialog2, m_StatusDialog2);
	DDV_MaxChars(pDX, m_StatusDialog2, 256);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CStatusDialog, CDialog)
	//{{AFX_MSG_MAP(CStatusDialog)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CStatusDialog message handlers


void	CleanUpGlobalData( void )
	{
	char	TempString[ 257 ];
	int	TempInt;

	strcpy( TempString, GlobalDriveLetter );
	strupr( TempString );
	Trim( TempString );
	if (TempString[ 0 ] < 'A')
		strcpy( TempString, "F" );
	if (TempString[ 0 ] > 'Z')
		strcpy( TempString, "F" );
	strcpy( GlobalDriveLetter, TempString );		

	strcpy( TempString, GlobalServerName );
	strupr( TempString );
	Trim( TempString );
	TempInt = InChar( 1, TempString, '.');
	if (TempInt > 0)
		TempString[ TempInt -1 ] = '\0';
	TempInt = InChar( 1, TempString, '/');
	if (TempInt > 0)
		TempString[ TempInt -1 ] = '\0';
	TempInt = InChar( 1, TempString, ':');
	if (TempInt > 0)
		TempString[ TempInt -1 ] = '\0';
	strcpy( GlobalServerName, TempString );
	
	strcpy( TempString, GlobalSubdirectoryName );
	strupr( TempString );
	Trim( TempString );
	TempInt = InChar( 1, TempString, '.');
	if (TempInt > 0)
		TempString[ TempInt -1 ] = '\0';
	TempInt = InChar( 1, TempString, '/');
	if (TempInt > 0)
		TempString[ TempInt -1 ] = '\0';
	strcpy( GlobalSubdirectoryName, TempString );
	
	strcpy( TempString, GlobalUserName );
	strupr( TempString );
	Trim( TempString );
	TempInt = InChar( 1, TempString, '.');
	if (TempInt > 0)
		TempString[ TempInt -1 ] = '\0';
	TempInt = InChar( 1, TempString, '/');
	if (TempInt > 0)
		TempString[ TempInt -1 ] = '\0';
	strcpy( GlobalUserName, TempString );
	
	strcpy( TempString, GlobalPassword );
	strupr( TempString );
	Trim( TempString );
	TempInt = InChar( 1, TempString, '.');
	if (TempInt > 0)
		TempString[ TempInt -1 ] = '\0';
	TempInt = InChar( 1, TempString, '/');
	if (TempInt > 0)
		TempString[ TempInt -1 ] = '\0';
	if (stricmp( TempString, "NA" ) == 0)
		TempString[ 0 ] = '\0';
	if (stricmp( TempString, "NONE" ) == 0)
		TempString[ 0 ] = '\0';
	if (stricmp( TempString, "*" ) == 0)
		TempString[ 0 ] = '\0';
	strcpy( GlobalPassword, TempString );
	
   }



